routes/admin.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Administrator Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', 'HomeController@index')->name('dashboard');

// Route::get('/author', 'AuthorController@index')->name('author');
// Route::get('/author/create', 'AuthorController@create')->name('author.create');
// Route::post('/author', 'AuthorController@store')->name('author.store');
// Route::get('/author/{author}/edit', 'AuthorController@edit')->name('author.edit');
// Route::put('/author/{author}', 'AuthorController@update')->name('author.update');
// Route::delete('/author/{author}', 'AuthorController@destroy')->name('author.destroy');

//Datatables
Route::get('/author/data', 'DataCenterController@authorDatatable')->name('author.data');
Route::get('/book/data', 'DataCenterController@bookDatatable')->name('book.data');
Route::get('/borrow/data', 'DataCenterController@borrowDatatable')->name('borrow.data');
//-----------------------------------------------------------------------------------------


Route::resource('/author', 'AuthorController');
Route::resource('/book', 'BookController');

Route::get('/borrow', 'BorrowController@index')->name('borrow.index');
Route::put('/borrow/{borrow}', 'BorrowController@update')->name('borrow.update');

Route::get('/report/top-book', 'ReportController@topBook')->name('report.top-book');
Route::get('/report/top-user', 'ReportController@topUser')->name('report.top-user');

routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', 'Frontend\\FrontendController@homePage')->name('homepage');
Route::get('/book/{book}', 'Frontend\\FrontendController@showBook')->name('book.show');
Route::post('/book/{book}/borrow', 'Frontend\\FrontendController@borrow')->name('book.borrow')->middleware(['auth']);

Auth::routes(['verify' => true]);

Route::get('/home', 'HomeController@index')->name('home')->middleware('verified');

app/Book.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Book extends Model
{	
    protected $guarded = [];

    public function author()
    {
        return $this->belongsTo(Author::class);
    }

    public function getCover()
    {
    	if (substr($this->cover, 0, 5) == 'https') {
    		return $this->cover; 
    	}

    	if ($this->cover) {
    		return asset($this->cover);
    	}

    	return 'https://via.placeholder.com/150x200.png?text=No+Cover';
    }

    public function borrowed()
    {
        return $this->belongsToMany(Book::class, 'borrow_history')->withTimestamps();
    }

    public function borrowHistory()
    {
        return $this->belongsTo(BorrowHistory::class);
    }

    public function scopeIsStillBorrow($query, $bookId)
    {
        return $query->where('book_id', $bookId)->where('return_at', null)->count() > 0;
    }
    
}

app/Http/Controllers/Admin/BookController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Book;
use App\Author;
use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Storage;

class BookController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        return view('admin.book.index', [
            'title' => 'Data Buku'
        ]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {       
       $author = Author::orderBy('name', 'asc')->get();

       return view('admin.book.create', [
            'title' => 'Tambah Buku',
            'name_author' => $author
        ]);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $this->validate($request, [
            'author_id'     => 'required',
            'title'         => 'required',
            'description'   => 'required|min:10',
            'cover'         => 'file|image',
            'qty'           => 'required|numeric'
        ]);

        $cover = null;

        if ($request->hasFile('cover')) {
            $cover = $request->file('cover')->store('assets/covers');
        }

        Book::create([
            'author_id'     => $request->author_id,
            'title'         => $request->title,
            'description'   => $request->description,
            'cover'         => $cover,
            'qty'           => $request->qty
        ]);

        return redirect()->route('admin.book.index')
            ->withSuccess('Data buku berhasil ditambahkan');
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Book  $book
     * @return \Illuminate\Http\Response
     */
    public function show(Book $book)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Book  $book
     * @return \Illuminate\Http\Response
     */
    public function edit(Book $book)
    {
        $author = Author::orderBy('name', 'asc')->get();

        return view('admin.book.edit', [
            'book' => $book,
            'name_author' => $author,
            'title' => 'Edit Data Buku'
        ]);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Book  $book
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Book $book)
    {
        $this->validate($request, [
            'author_id'     => 'required',
            'title'         => 'required',
            'description'   => 'required|min:10',
            'cover'         => 'file|image',
            'qty'           => 'required|numeric'
        ]);

        $cover = $book->cover;

        if ($request->hasFile('cover')) {
            storage::delete($book->cover);
            $cover = $request->file('cover')->store('assets/covers');
        }

        $book->update([
            'author_id'     => $request->author_id,
            'title'         => $request->title,
            'description'   => $request->description,
            'cover'         => $cover,
            'qty'           => $request->qty
        ]);

        return redirect()->route('admin.book.index')
            ->withInfo('Data buku berhasil diperbaharui!');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Book  $book
     * @return \Illuminate\Http\Response
     */
    public function destroy(Book $book)
    {
        storage::delete($book->cover);
        $book->delete();

       return redirect()->route('admin.book.index')
       ->with('danger', 'Data berhasil dihapus!');
    }
}

resources/views/admin/book/action.blade.php
<a href="{{ route('admin.book.edit', $model) }}" class="btn btn-xs btn-warning">Edit</a>
<button href="{{ route('admin.book.destroy', $model) }}" class="btn btn-xs btn-danger" id="delete">Hapus</button>

<link href="//cdn.jsdelivr.net/npm/@sweetalert2/theme-dark@3/dark.css" rel="stylesheet">
<script src="//cdn.jsdelivr.net/npm/sweetalert2@9/dist/sweetalert2.min.js"></script>

<script src="https://cdn.jsdelivr.net/npm/sweetalert2@8"></script>
<script>
    $('button#delete').on('click', function(e){
        e.preventDefault();
        var href = $(this).attr('href');

        const swalWithBootstrapButtons = Swal.mixin({
		  customClass: {
		    confirmButton: 'btn btn-sm btn-success',
		    cancelButton: 'btn btn-sm btn-danger'
		  },
		  buttonsStyling: false
		});

		Swal.fire({
		  title: 'Apakah kamu yakin?',		   	  
		  text: "Anda tidak akan dapat mengembalikannya!",
		  icon: 'warning',		  
		  showCancelButton: true,
		  confirmButtonText: 'Ya, Hapus ini!',
		  cancelButtonText: 'Tidak, Batalkan!', 
		}).then((result) => {
		  if (result.value) {
		  	document.getElementById('deleteForm').action = href;
            document.getElementById('deleteForm').submit();

		    swalWithBootstrapButtons.fire(
		      'Terhapus!',
		      'Data berhasil dihapus dari sistem.',
		      'success'
		    )
		  } else if (
		    result.dismiss === Swal.DismissReason.cancel
		  ) {
		    swalWithBootstrapButtons.fire(
		      'Dibatalkan',
		      'Data berhasil diamakan :)',
		      'error'
		    )
		  }
		});        
    });
</script>

resources/views/admin/book/create.blade.php
@extends('admin.template.default')

@section('content')
<div class="card">
    <div class="card-header">
         <h3 class="card-title">Tambah Data Buku</h3>         
    </div>
    <div class="card-body">
		<form action="{{ route('admin.book.store') }}" method="POST" enctype="multipart/form-data">
		@csrf

		  <div class="form-group row">
			    <label for="author_id" class="col-sm-2 col-form-label">Nama Penulis</label>
			    <div class="col-sm-10">
			      <select name="author_id" class="form-control custom-select @error('author_id') is-invalid @enderror select2" id="author_id">
			      <option value="">Pilih Nama Penulis</option>
			      	@foreach($name_author as $author)
			      	<option value="{{ $author->id }}">{{ $author->name }}</option>
			      	@endforeach			      	
			      </select>
				    @error('author_id') 
				       <span class="help-block">{{ $message }}</span>	
				    @enderror
			    </div>
		  </div>
		  <div class="form-group row">
			    <label for="title" class="col-sm-2 col-form-label">Judul</label>
			    <div class="col-sm-10">
			      <input type="text" class="form-control @error('title') is-invalid @enderror" id="title" name="title" placeholder="Masukan judul buku..." value="{{ old('title') }}">
				    @error('title') 
				       <span class="help-block">{{ $message }}</span>	
				    @enderror
			    </div>
		  </div>
		  <div class="form-group row">
			    <label for="description" class="col-sm-2 col-form-label">Deskripsi</label>
			    <div class="col-sm-10">			    
			      <textarea name="description" class="form-control @error('description') is-invalid @enderror" id="description" rows="3">{{ old('description') }}</textarea>
				    @error('description') 
				       <span class="help-block">{{ $message }}</span>	
				    @enderror
			    </div>
		  </div>
		  <div class="form-group row">
			    <label for="cover" class="col-sm-2 col-form-label">Sampul</label>
			    <div class="col-sm-10">			     	
					<input type="file" class="form-control-file @error('cover') is-invalid @enderror" id="cover" name="cover" value="{{ old('cover') }}">
		     		 @error('cover') 
		     	       <span class="help-block">{{ $message }}</span>	
		     	   	 @enderror					
			    </div>
		  </div>
		  <div class="form-group row">
			    <label for="qty" class="col-sm-2 col-form-label">Jumlah</label>
			    <div class="col-sm-10">
			      <input type="number" class="form-control @error('qty') is-invalid @enderror" id="qty" name="qty" min="0" value="{{ old('qty') }}">
				    @error('qty') 
				       <span class="help-block">{{ $message }}</span>	
				    @enderror
			    </div>
		  </div>
		  

		  <div class="form-group row">
		    <div class="col-sm-12">
		    	<input type="submit" value="Simpan" class="btn btn-success btn-sm float-right">		    	
		    </div>
		  </div>
		  
		</form>
    </div>
</div>
@endsection

@push('select2')
	<link rel="stylesheet" href="{{ asset('assets/plugins/select2/css/select2.min.css') }}">
@endpush

@push('jquery')
	<script src="{{ asset('assets/plugins/select2/js/select2.full.min.js') }}"></script>
@endpush

@push('scripts')
	<script>
		$('.select2').select2();
	</script>
@endpush

resources/views/admin/book/edit.blade.php
@extends('admin.template.default')

@section('content')
<div class="card">
    <div class="card-header">
         <h3 class="card-title">Edit Data Penulis</h3>         
    </div>
    <div class="card-body">
		<form action="{{ route('admin.book.update', [$book->id]) }}" method="POST" enctype="multipart/form-data">
		@csrf
		@method('PUT')
		  <div class="form-group row">
			    <label for="author_id" class="col-sm-2 col-form-label">Nama Penulis</label>
			    <div class="col-sm-10">
			      <select name="author_id" class="form-control custom-select @error('author_id') is-invalid @enderror select2" id="author_id">
			      <option value="">Pilih Nama Penulis</option>
			      	@foreach($name_author as $author)
			      	<option value="{{ $author->id }}"
			      		@if($author->id == $book->author_id)
							selected
			      		@endif 
			      		>{{ $author->name }}</option>
			      	@endforeach			      	
			      </select>
				    @error('author_id') 
				       <span class="help-block">{{ $message }}</span>	
				    @enderror
			    </div>
		  </div>
		  <div class="form-group row">
			    <label for="title" class="col-sm-2 col-form-label">Judul</label>
			    <div class="col-sm-10">
			      <input type="text" class="form-control @error('title') is-invalid @enderror" id="title" name="title" placeholder="Masukan judul buku..." value="{{ old('title') ?? $book->title }}">
				    @error('title') 
				       <span class="help-block">{{ $message }}</span>	
				    @enderror
			    </div>
		  </div>
		  <div class="form-group row">
			    <label for="description" class="col-sm-2 col-form-label">Deskripsi</label>
			    <div class="col-sm-10">			    
			      <textarea name="description" class="form-control @error('description') is-invalid @enderror" id="description" rows="3">{{ old('description') ?? $book->description }}</textarea>
				    @error('description') 
				       <span class="help-block">{{ $message }}</span>	
				    @enderror
			    </div>
		  </div>
		  <div class="form-group row">
			    <label for="cover" class="col-sm-2 col-form-label">Sampul</label>
			    <div class="col-sm-10">			     	
					<input type="file" class="form-control-file @error('cover') is-invalid @enderror" id="cover" name="cover" value="{{ old('cover') ?? $book->cover }}">
		     		 @error('cover') 
		     	       <span class="help-block">{{ $message }}</span>	
		     	   	 @enderror					
			    </div>
		  </div>
		  <div class="form-group row">
			    <label for="qty" class="col-sm-2 col-form-label">Jumlah</label>
			    <div class="col-sm-10">
			      <input type="number" class="form-control @error('qty') is-invalid @enderror" id="qty" name="qty" min="0" value="{{ old('qty') ?? $book->qty }}">
				    @error('qty') 
				       <span class="help-block">{{ $message }}</span>	
				    @enderror
			    </div>
		  </div>

		  <div class="form-group row">
		    <div class="col-sm-12">
		    	<input type="submit" value="Ubah" class="btn btn-success btn-sm float-right">		    	
		    </div>
		  </div>		  
		</form>
    </div>
</div>
@endsection

@push('select2')
	<link rel="stylesheet" href="{{ asset('assets/plugins/select2/css/select2.min.css') }}">
@endpush

@push('jquery')
	<script src="{{ asset('assets/plugins/select2/js/select2.full.min.js') }}"></script>
@endpush

@push('scripts')
	<script>
		$('.select2').select2();
	</script>
@endpush

resources/views/admin/book/index.blade.php
@extends('admin.template.default')

@section('content')

<div class="card">
    <div class="card-header">
         <h3 class="card-title">Data Buku</h3>
         <a href="{{ route('admin.book.create') }}" class="btn btn-primary btn-sm float-right">Tambah Buku</a>
    </div>
    <div class="card-body">

		

		<table id="authorData" class="table table-bordered table-hover text-sm table-sm">
		 	<thead>
		 		<tr>
		 			<th>No</th>
		 			<th>Sampul</th>
		 			<th>Nama Penulis</th>
		 			<th>Judul</th>
		 			<th>Deskripsi</th>
		 			<th>Jumlah</th>
		 			<th>Aksi</th>
		 		</tr>
		 	</thead>
		 	<tbody>
		 		<tr></tr>
		 	</tbody>
		 </table>
    </div>
</div>
<form action="" method="post" id="deleteForm">
    @csrf
    @method("DELETE")
    <input type="submit" value="Hapus" style="display: none">
</form>
@endsection

@push('styles')
	 <link rel="stylesheet" href="{{ asset('assets/plugins/datatables-bs4/css/dataTables.bootstrap4.min.css') }}">
	 <link rel="stylesheet" href="{{ asset('assets/plugins/datatables-responsive/css/responsive.bootstrap4.min.css') }}"> 
@endpush


@push('jquery')
	<script src="{{ asset('assets/plugins/datatables/jquery.dataTables.min.js') }}"></script>
	<script src="{{ asset('assets/plugins/datatables-bs4/js/dataTables.bootstrap4.min.js') }}"></script>
	<script src="{{ asset('assets/plugins/datatables-responsive/js/dataTables.responsive.min.js') }}"></script>
	<script src="{{ asset('assets/plugins/datatables-responsive/js/responsive.bootstrap4.min.js') }}"></script>
	<script src="{{ asset('assets/plugins/bootstrap-notify/bootstrap-notify.min.js') }}"></script>	
@endpush

@push('scripts')
	@include('admin.template.partials.alerts')
<script>
	$(function () {
		$('#authorData').DataTable({
		 		processing: true,
                serverSide: true,
                ajax: '{{ route('admin.book.data') }}',
                columns: [
                	{ data: 'DT_RowIndex', orderable: false, searchable : false},                
                    { data: 'cover', orderable: false, searchable : false},                 
                    { data: 'author'},
                    { data: 'title'},
                    { data: 'description'},
                    { data: 'qty'},
                    { data: 'action'}
                ]                         
		});
	});
</script>
@endpush